from re import compile

from dosage.helpers import BasicScraper


class BadlyDrawnKitties(BasicScraper):
    latestUrl = 'http://www.badlydrawnkitties.com/'
    imageUrl = 'http://www.badlydrawnkitties.com/new/%s.html'
    imageSearch = compile(r'<img src="(/new/.+?)">')
    prevSearch = compile(r'"(/new/.+?)".+?previous.gif')
    help = 'Index format: n (unpadded)'


class Bardsworth(BasicScraper):
    latestUrl = 'http://www.bardsworth.com/'
    imageUrl = 'http://www.bardsworth.com/archive.php?p=s%'
    imageSearch = compile(r'(strips/.+?)"')
    prevSearch = compile(r'"(http.+?)".+?/prev')
    help = 'Index format: nnn'


class BetterDays(BasicScraper):
    latestUrl = 'http://www.jaynaylor.com/betterdays/'
    imageUrl = 'http://www.jaynaylor.com/betterdays/archives/%s'
    imageSearch = compile(r'<img src=(/betterdays/comic/.+?)>')
    prevSearch = compile(r'<a href="(.+)">&laquo; Previous')
    help = 'Index format: yyyy/mm/<your guess>.html'


class BetterYouThanMe(BasicScraper):
    latestUrl = 'http://betteryouthanme.net/'
    imageUrl = 'http://betteryouthanme.net/archive.php?date=%s.gif'
    imageSearch = compile(r'"(comics/.+?)"')
    prevSearch = compile(r'"(archive.php\?date=.+?)">.+?previous')
    help = 'Index format: yyyymmdd'


class BiggerThanCheeses(BasicScraper):
    latestUrl = 'http://www.biggercheese.com'
    imageUrl = 'http://www.biggercheese.com/index.php?comic=%s'
    imageSearch = compile(r'src="(comics/.+?)" alt')
    prevSearch = compile(r'"(index.php\?comic=.+?)".+?_back')
    help = 'Index format: n (unpadded)'


class BizarreUprising(BasicScraper):
    latestUrl = 'http://www.bizarreuprising.com/bu.php'
    imageUrl = 'http://www.bizarreuprising.com/bu.php?strip_id=%s'
    imageSearch = compile(r'<img src="(img/comics/bu/.+?)"')
    prevSearch = compile(r'<a href="(\?strip_id=\d+?)"><img src="img/nav/bu_prev.gif"')
    help = 'Index format: yymmdd'


class Blip(BasicScraper):
    latestUrl = 'http://blipcomic.com/'
    imageUrl = 'http://blipcomic.com/index.php?strip_id=%s'
    imageSearch = compile(r'(istrip_files/strips/.+?)"')
    prevSearch = compile(r'First.+?"(index.php\?strip_id=.+?)".+?prev')
    help = 'Index format: n'


class BlueCrashKit(BasicScraper):
    latestUrl = 'http://www.bluecrashkit.com/cheese/'
    imageUrl = 'http://www.bluecrashkit.com/cheese/node/%s'
    imageSearch = compile(r'(/cheese/files/comics/.+?)"')
    prevSearch = compile(r'(/cheese/node/.+?)".+?previous')
    help = 'Index format: non'


class BMovieComic(BasicScraper):
    latestUrl = 'http://www.bmoviecomic.com/'
    imageUrl = 'http://www.bmoviecomic.com/?cid=%s'
    imageSearch = compile(r'"(comics/.+?)"')
    prevSearch = compile(r'(\?cid=.+?)".+?Prev')
    help = 'Index format: n'


### With BratHalla there is no 'previous' link at comic 360
### You will need to use
### mainline -c BratHalla:360-backup-dad-unstable-plans/
### to get earlier comics
class BratHalla(BasicScraper):
    latestUrl = 'http://brat-halla.com/'
    imageUrl = 'http://brat-halla.com/comic/%s'
    imageSearch = compile(r"(/comics/.+?)' target='_blank")
    prevSearch = compile(r'headernav2".+?"(http.+?)"')
    help = 'Index format: non'


class Brink(BasicScraper):
    latestUrl = 'http://paperfangs.com/brink/'
    imageUrl = 'http://paperfangs.com/brink/?p=%s'
    imageSearch = compile(r'/(comics/.+?)"')
    prevSearch = compile(r'previous.+?/brink/(.+?)".+?Previous')
    help = 'Index format: non'


class BrokenMirror(BasicScraper):
    latestUrl = 'http://www.the-broken-mirror.net/files/story/comic.php'
    imageUrl = 'http://www.the-broken-mirror.net/files/story/comic.php\?id=%s'
    imageSearch = compile(r'"(/files/story/.+?)"')
    prevSearch = compile(r'href="(comic.php\?id=.+?)">&lt;&lt;BACK')
    help = 'Index format: n'


class BonoboConspiracy(BasicScraper):
    latestUrl = 'http://ansuz.sooke.bc.ca/bonobo-conspiracy/'
    imageUrl = 'http://ansuz.sooke.bc.ca/bonobo-conspiracy/%s'
    imageSearch = compile(r'<P.+?<IMG SRC="(.+?)" ALT')
    prevSearch = compile(r'ansuz.+?/(\?i=.+?)".+?Previous')
    help = 'Index format: nnn'


class BoredAndEvil(BasicScraper):
    latestUrl = 'http://www.boredandevil.com/'
    imageUrl = 'http://www.boredandevil.com/archive.php?date=%s'
    imageSearch = compile(r'<img src="(strips/.+?)"')
    prevSearch = compile(r'First Comic.+<a href="(.+?)".+previous-on.gif')
    help = 'Index format: yyyy-mm-dd'



class BoyOnAStickAndSlither(BasicScraper):
    latestUrl = 'http://www.boasas.com/'
    imageUrl = 'http://www.boasas.com/?c=%s'
    imageSearch = compile(r'"(boasas/\d+\..+?)"')
    prevSearch = compile(r'<a href="(.+?)"><img src="images/left_20.png"')
    help = 'Index format: n (unpadded)'



class ButternutSquash(BasicScraper):
    latestUrl = 'http://www.butternutsquash.net/assets/pages/bns-current.html'
    imageUrl = 'http://www.butternutsquash.net/assets/pages/bns-comic%s.html'
    imageSearch = compile(r'<img src="(\.\./library/.+?)"')
    prevSearch = compile(r'<area shape="rect" coords="\d+,2\d,13\d,\d+" href="(bns-.+?\.html)" target="_self">')
    help = 'Index format: nn'


class Bhag(BasicScraper):
    latestUrl = 'http://bhag.sackofjustice.com/'
    imageUrl = 'http://bhag.sackofjustice.com/daily.php?date='
    imageSearch = compile(r'/(comics/.+?)">')
    prevSearch = compile(r'first.+?/(daily.php\?date=.+?)".+?previous')
    help = 'Index format: yymmdd'

def blankLabel(name, baseUrl):
    return BasicScraper.make(
        name='BlankLabel/' + name,
        latestUrl=baseUrl,
        imageUrl='d/%s.html',
        imageSearch=compile(r'"(/comic[s|/].+?)"'),
        prevSearch=compile(r'(?:"([^"]*(?:/d/[^"\r\n]*)|(?:/strip/.+?))")(?:(?:.{43}starshift_back.gif)|(?:.+?cxn_previous)|(?:.{43}previous)|(?:[^<>]*>[^<>]*<[^<>]*previous)|(?:.*?back_button)|(?:.*?comicnav-previous))'),
        help='Index format: yyyymmdd')


checkerboardNightmare = blankLabel('CheckerboardNightmare', 'http://www.checkerboardnightmare.com/')
courtingDisaster = blankLabel('CourtingDisaster', 'http://www.courting-disaster.com/')
evilInc = blankLabel('EvilInc', 'http://www.evil-comic.com/')
greystoneInn = blankLabel('GreystoneInn', 'http://www.greystoneinn.net/')
itsWalky = blankLabel('ItsWalky', 'http://www.itswalky.com/')
# one strip name starts with %20
#krazyLarry = blankLabel('KrazyLarry', 'http://www.krazylarry.com/')
melonpool = blankLabel('Melonpool', 'http://www.melonpool.com/')
# strip names = index.php
#realLife = blankLabel('RealLife', 'http://www.reallifecomics.com/')
schlockMercenary = blankLabel('SchlockMercenary', 'http://www.schlockmercenary.com/')
# hosted on ComicsDotCom
#sheldon = blankLabel('Sheldon', 'http://www.sheldoncomics.com/')
shortpacked = blankLabel('Shortpacked', 'http://www.shortpacked.com/')
starslipCrisis = blankLabel('StarslipCrisis', 'http://www.starslipcrisis.com/')
uglyHill = blankLabel('UglyHill', 'http://www.uglyhill.com/')
wapsiSquare = blankLabel('WapsiSquare', 'http://www.wapsisquare.com/')



class BeePower(BasicScraper):
    latestUrl = 'http://comicswithoutviolence.com/d/20080713.html'
    imageUrl = 'http://comicswithoutviolence.com/d/%s.html'
    imageSearch = compile(r'src="(/comics/.+?)"')
    prevSearch = compile(r'(\d+\.html)"><img[^>]+?src="/images/previous_day.png"')
    help = 'Index format: yyyy/mm/dd'



class Bellen(BasicScraper):
    latestUrl = 'http://boxbrown.com/'
    imageUrl = 'http://boxbrown.com/?p=%s'
    imageSearch = compile(r'<img src="(http://boxbrown.com/comics/[^"]+)"')
    prevSearch = compile(r'<a href="(.+?)"><span class="prev">')
    help = 'Index format: nnn'
