from re import compile

from dosage.helpers import BasicScraper, indirectStarter


class Galaxion(BasicScraper):
    latestUrl = 'http://galaxioncomics.com/'
    imageUrl = 'http://galaxioncomics.com/?p=%s'
    imageSearch = compile(r'(wordpress/comics/.+?)"')
    prevSearch = compile(r'\| <a href="http://galaxioncomics.com/(\?p=.+?)".+?vious.gif')
    help = 'Index format: non'


class Garanos(BasicScraper):
    latestUrl = 'http://www.garanos.com/'
    imageUrl = 'http://www.garanos.com/pages/page-%s'
    imageSearch = compile(r'<img src=.+?(/pages/.+?)"')
    prevSearch = compile(r'<a href="(http://www.garanos.com/pages/page-.../)">&#9668; Previous<')
    help = 'Index format: n  (unpadded)'


class GUComics(BasicScraper):
    latestUrl = 'http://www.gucomics.com/comic/'
    imageUrl = 'http://www.gucomics.com/comic/?cdate=%s'
    imageSearch = compile(r'<IMG src="(/comics/\d{4}/gu_.*?)"')
    prevSearch = compile(r'<A href="(/comic/\?cdate=\d+)"><IMG src="/images/cnav_prev')
    help = 'Index format: yyyymmdd'


class GenrezvousPoint(BasicScraper):
    latestUrl = 'http://www.iccomics.com/chapters/genrezvouspoint/index.php?id=120'
    imageUrl = 'http://www.iccomics.com/chapters/genrezvouspoint/index.php?id=%s'
    imageSearch = compile(r'src="(.*?gp-comics/.*?)"')
    prevSearch = compile(r'</a><a href="(.+?index.php\?id=.*?)".*?navbar_03')
    help = 'Index format: n (unpadded)'


class GirlGenius(BasicScraper):
    latestUrl = 'http://girlgeniusonline.com/comic.php'
    imageUrl = 'http://www.girlgeniusonline.com/comic.php\?date=%s'
    imageSearch = compile(r"(/ggmain/strips/.+?)'")
    prevSearch = compile(r"</a> <a href=.+?(/comic.php\?date=.+?)'.+?Previous")
    help = 'Index format: yyyymmdd'



class GirlsWithSlingshots(BasicScraper):
    latestUrl = 'http://www.daniellecorsetto.com/gws.html'
    imageUrl = 'http://www.daniellecorsetto.com/GWS%s.html'
    imageSearch = compile(r'<img src="(images/gws/GWS\d{3}.jpg)"')
    prevSearch = compile(r'(archive.php\?today=\d{3}&comic=\d{3})"[^>]*><img[^>]+src="images/gwsmenu/back_off.jpg"')
    help = 'Index format: nnn'



class Girly(BasicScraper):
    latestUrl = 'http://go-girly.com/'
    imageUrl = 'http://go-girly.com/go/%s'
    imageSearch = compile(r'"(http://comics.go-girly.com/.*?)"')
    prevSearch = compile(r"<a href=\'(/go/.*?)\'.+?nav_girly_prev.gif")
    help = 'Index format: nnn'


class GlueMeat(BasicScraper):
    latestUrl = 'http://www.gluemeat.com/'
    imageUrl = 'http://www.gluemeat.com/archives/%s.html'
    imageSearch = compile(r'<img.+?src="(http://www.gluemeat.com/comics/\d{8}\..+?)"')
    prevSearch = compile(r'(?:<a|<link rel="prev") href="(http://www.gluemeat.com/archives/\d{6}\.html)"(?!>Comment on this comic)(?:.+?</a> \]</font>)?')
    help = 'Index format: nnnnnn'


class Goats(BasicScraper):
    latestUrl = 'http://www.goats.com/'
    imageUrl = 'http://www.goats.com/archive/%s.html'
    imageSearch = compile(r'<img.+?src="(/comix/.+?)"')
    prevSearch = compile(r'<a href="(/archive/\d{6}.html)" class="button" title="go back">')
    help = 'Index format: yymmdd'



class GoneWithTheBlastwave(BasicScraper):
    starter = indirectStarter('http://www.blastwave-comic.com/index.php?p=comic&nro=1',
                              compile(r'href="(index.php\?p=comic&amp;nro=\d+)"><img src="images/page/default/latest'))
    imageUrl = 'http://www.blastwave-comic.com/index.php?p=comic&nro=%s'
    imageSearch = compile(r'<img.+src=".+(/comics/.+?)"')
    prevSearch = compile(r'href="(index.php\?p=comic&amp;nro=\d+)"><img src="images/page/default/previous')
    help = 'Index format: n'

    def namer(cls, imageUrl, pageUrl):
        return '%02d' % int(compile(r'nro=(\d+)').search(pageUrl).group(1))



class GunnerkrigCourt(BasicScraper):
    latestUrl = 'http://www.gunnerkrigg.com/index2.php'
    imageUrl = 'http://www.gunnerkrigg.com/archive_page.php\?comicID=%s'
    imageSearch = compile(r'<img src="(.+?//comics/.+?)"')
    prevSearch = compile(r'<.+?(/archive_page.php\?comicID=.+?)".+?prev')
    help = 'Index format: n'



class Gunshow(BasicScraper):
    latestUrl = 'http://gunshowcomic.com/'
    imageUrl = 'http://gunshowcomic.com/d/%s.html'
    imageSearch = compile(r'src="(/comics/.+?)"')
    prevSearch = compile(r'(/d/\d+\.html)"><img[^>]+?src="/images/previous_day')
    help = 'Index format: yyyy/mm/dd'
