from re import compile

from dosage.helpers import BasicScraper



class HappyMedium(BasicScraper):
    latestUrl = 'http://happymedium.fast-bee.com/'
    imageUrl = 'http://happymedium.fast-bee.com/%s'
    imageSearch = compile(r'(/comics/.+?)"')
    prevSearch = compile(r'com(/.+?)".+?"prev">&#9668')
    help = 'Index format: yyyy/mm/chapter-n-page-n'



class Heliothaumic(BasicScraper):
    latestUrl = 'http://thaumic.net/'
    imageUrl = 'http://thaumic.net/%s'
    imageSearch = compile(r'"(http://thaumic.net/comics/.+?)"')
    prevSearch = compile(r'"(http://thaumic.net/.+?)".+?="prev"')
    help = 'Index format: yyyy/mm/dd/n(unpadded)-comicname'



class Housd(BasicScraper):
    latestUrl = 'http://www.housd.net/'
    imageUrl = 'http://housd.net/archive_page.php?comicID=%s'
    imageSearch = compile(r'"(.+?/comics/.+?)"')
    prevSearch = compile(r'"(h.+?comicID=.+?)".+?prev')
    help = 'Index format: nnnn'



class HateSong(BasicScraper):
    latestUrl = 'http://hatesong.com/'
    imageUrl = 'http://hatesong.com/%s/'
    imageSearch = compile(r'src="(http://www.hatesong.com/strips/.+?)"')
    prevSearch = compile(r'<div class="headernav"><a href="(http://hatesong.com/\d{4}/\d{2}/\d{2})')
    help = 'Index format: yyyy/mm/dd'



class HorribleVille(BasicScraper):
    latestUrl = 'http://horribleville.com/d/20090517.html'
    imageUrl = 'http://horribleville.com/d/%s.html'
    imageSearch = compile(r'src="(/comics/.+?)"')
    prevSearch = compile(r'(\d+\.html)"><img[^>]+?src="/images/previous_day.png"')
    help = 'Index format: yyyy/mm/dd'



class HelpDesk(BasicScraper):
    latestUrl = 'http://www.ubersoft.net/'
    imageUrl = 'http://www.ubersoft.net/comic/hd/%s/%s/%s'
    imageSearch = compile(r'src="(http://www.ubersoft.net/files/comics/hd/hd\d{8}.png)')
    prevSearch = compile(r'<a href="(/comic/.+?)">(.+?)previous</a>')
    help = 'Index format: yyyy/mm/name'
