from re import compile, IGNORECASE

from dosage.helpers import BasicScraper, queryNamer


class MadamAndEve(BasicScraper):
    latestUrl = 'http://www.madamandeve.co.za/week_of_cartns.php'
    imageUrl = 'http://www.madamandeve.co.za/week_of_cartns.php'
    imageSearch = compile(r'<IMG BORDER="0" SRC="(cartoons/me\d{6}\.(gif|jpg))">')
    prevSearch = compile(r'<a href="(weekend_cartoon.php)"')
    help = 'Index format: (none)'


class MagicHigh(BasicScraper):
    latestUrl = 'http://www.doomnstuff.com/magichigh/index.php'
    imageUrl = 'http://www.doomnstuff.com/magichigh/index.php?strip_id=%s'
    imageSearch = compile(r'(istrip_files/strips/.+?)"')
    prevSearch = compile(r'First .+?"(/magichigh.+?)".+?top_back')
    help = 'Index format: n'


class MakeWithTheFunny(BasicScraper):
    latestUrl = 'http://www.mwtfunny.com/'
    imageUrl = 'http://www.mwtfunny.com/index.php?ComicID=%s'
    imageSearch = compile(r'<img src=".+?(strips/\d{4}-\d{2}-\d{2}\..+?)">')
    prevSearch = compile(r'href="(index.php\?ComicID=.+?)" alt=".+?previous')
    help = 'Index format: n (unpadded)'


class Marilith(BasicScraper):
    latestUrl = 'http://www.marilith.com/'
    imageUrl = 'http://www.marilith.com/archive.php?date=%s'
    imageSearch = compile(r'<img src="(comics/.+?)" border')
    prevSearch = compile(r'<a href="(archive\.php\?date=.+?)"><img border=0 name=previous_day')
    help = 'Index format: yyyymmdd'


class MarryMe(BasicScraper):
    latestUrl = 'http://marrymemovie.com/main/'
    imageUrl = 'http://marrymemovie.com/main/%s'
    imageSearch = compile(r'(/comicfolder/.+?)"')
    prevSearch = compile(r'Previous.+?(/main/.+?)">Page')
    help = 'Index format: good luck !'


class MegaTokyo(BasicScraper):
    latestUrl = 'http://www.megatokyo.com/'
    imageUrl = 'http://www.megatokyo.com/strip/%s'
    imageSearch = compile(r'"(strips/.+?)"', IGNORECASE)
    prevSearch = compile(r'"(./strip/\d+?)">Prev')
    help = 'Index format: nnnn'


class MyPrivateLittleHell(BasicScraper):
    latestUrl = 'http://mutt.purrsia.com/mplh/'
    imageUrl = 'http://mutt.purrsia.com/mplh/?date=%s'
    imageSearch = compile(r'<img.+?src="(comics/.+?)"')
    prevSearch = compile(r'<a.+?href="(\?date=\d+/\d+/\d+)">Prev</a>')
    help = 'Index format: mm/dd/yyyy'


class MacHall(BasicScraper):
    latestUrl = 'http://www.machall.com/'
    imageUrl = 'http://www.machall.com/index.php?strip_id=%s'
    imageSearch = compile(r'<img src="(comics/\d{4}\d{2}\d{2}\..*?)" border=0>')
    prevSearch = compile(r'<a href="(view\.php\?date=\d{4}-\d{2}-\d{2})"><img border=0 src=\'drop_shadow/previous.gif\'>')
    help = 'Index format: n (unpadded)'


class Misfile(BasicScraper):
    latestUrl = 'http://www.misfile.com/'
    imageUrl = 'http://www.misfile.com/?page=%s'
    imageSearch = compile(r'<img src="(overlay\.php\?pageCalled=\d+)">')
    prevSearch = compile(r'<a href="(\?page=\d+)"><img src="/images/back\.gif"')
    help = 'Index format: n (unpadded)'
    namer = queryNamer('pageCalled')


class MinesBigger(BasicScraper):
    basePath = 'http://minesbigger.novablade.com/phpcomic/'
    prevSearch = compile(r'<a href="(http://minesbigger\.novablade\.com/phpcomic/daily\.php\?date=\d{6})"><img src="../../images/phpprevious.gif')


class MysteriesOfTheArcana(BasicScraper):
    latestUrl = 'http://mysteriesofthearcana.com/'
    imageUrl = 'http://mysteriesofthearcana.com/index.php?action=comics&cid='
    imageSearch = compile(r'(image.php\?type=com&i=.+?)"')
    prevSearch = compile(r'(index.php\?action=comics&cid=.+?)".+?show_prev1')
    help = 'Index format: n (unpadded)'


class MysticRevolution(BasicScraper):
    latestUrl = 'http://www.mysticrev.com/index.php'
    imageUrl = 'http://www.mysticrev.com/index.php?cid=%s'
    imageSearch = compile(r'(comics/.+?)"')
    prevSearch = compile(r'(\?cid=.+?)".+?prev.gif')
    help = 'Index format: n (unpadded)'
