from re import compile, IGNORECASE

from dosage.helpers import BasicScraper, indirectStarter


class OctopusPie(BasicScraper):
    latestUrl = 'http://www.octopuspie.com/'
    imageUrl = 'http://www.octopuspie.com/%s'
    imageSearch = compile(r'(http://www.octopuspie.com/strippy/.+?)"')
    prevSearch = compile(r'<a href="(http.+?)".+?Previous<')
    help = 'Index format: yyyy-mm-dd/n-name/'


class OddFish(BasicScraper):
    latestUrl = 'http://www.odd-fish.net/'
    imageUrl = 'http://www.odd-fish.net/viewing.php?comic_id=%s'
    imageSearch = compile(r'<img src="(images/.+?)"')
    prevSearch = compile(r'"(viewing.php.+?)".+?older')
    help = 'Index format: n (unpadded)'


class OhMyGods(BasicScraper):
    latestUrl = 'http://ohmygods.timerift.net/'
    imageUrl = 'http://ohmygods.timerift.net/strips/%s.php'
    imageSearch = compile(r'<\!-- \#BeginEditable "strip" --><img src="((?:strips/\d{4}/\d{2}/)?\d{2}\..+?)" width="\d+" height="\d+" border="\d+">')
    prevSearch = compile(r'<a href="((?:strips/\d{4}/\d{2}/)?\d{2}\.php)">previous')
    help = 'Index format: yyyy/mm/dd'


class OkayPants(BasicScraper):
    latestUrl = 'http://www.okaypants.com/comic.php'
    imageUrl = 'http://www.okaypants.com/comic.php?st=%s'
    imageSearch = compile(r'"(comic/.+?)"')
    prevSearch = compile(r'"(.+?)".+previous')
    help = 'Index format: unknown'


class OnTheEdge(BasicScraper):
    latestUrl = 'http://www.ontheedgecomics.com'
    imageUrl = 'http://www.ontheedgecomics.com/comic/%s'
    imageSearch = compile(r'ontheedgecomics.com(/comics/.+?)"')
    prevSearch = compile(r'previous"><a href="http://ontheedgecomics.com(/comic.+?)">&lsaquo; Previous<')
    help = 'Index format: non'


class OneQuestion(BasicScraper):
    latestUrl = 'http://onequestioncomic.com/'
    imageUrl = 'http://onequestioncomic.com/comics/%s/'
    imageSearch = compile(r'(istrip_files.+?)"')
    prevSearch = compile(r'First.+?"(comic.php.+?)".+?previous.png')
    help = 'Index format: n (unpadded)'


class OtenbaFiles(BasicScraper):
    latestUrl = 'http://www.otenba-files.com/main.html'
    imageUrl = 'http://www.otenba-files.com/%s'
    imageSearch = compile(r'<img src="(comics/.+?)"')
    prevSearch = compile(r'href="(\d+.\d+.html)"><img src="Buttons/prev')
    help = 'Index format: n.nn'


class OurHomePlanet(BasicScraper):
    latestUrl = 'http://gdk.gd-kun.net/'
    imageUrl = 'http://gdk.gd-kun.net/%s.html'
    imageSearch = compile(r'<img src="(pages/comic.+?)"')
    prevSearch = compile(r'coords="50,18,95,65".+?href="(.+?\.html)".+?alt=')
    help = 'Index format: n (unpadded)'


class OkCancel(BasicScraper):
    imageUrl = 'http://www.ok-cancel.com/comic/%s.html'
    imageSearch = compile(r'src="(http://www.ok-cancel.com/strips/okcancel\d{8}.gif)"', IGNORECASE)
    prevSearch = compile(r'<div class="previous"><a href="(http://www.ok-cancel.com/comic/\d{1,4}.html)">', IGNORECASE)
    starter = indirectStarter('http://www.ok-cancel.com/', prevSearch)
    help = 'Index format: yyyymmdd'



class Oglaf(BasicScraper):
    starter = indirectStarter('http://oglaf.com/',
                              compile(r'<a href="(.+?)"><img src="over18.gif"', IGNORECASE))
    imageUrl = 'http://oglaf.com/%s.html'
    imageSearch = compile(r'/><img src="(.+?)"[^>]+?width="760" height="596"', IGNORECASE)
    prevSearch = compile(r'<a href="(.+?)"[^>]+?><img src="prev.gif"', IGNORECASE)
    help = 'Index format: nn'
