from re import compile, MULTILINE

from dosage.helpers import BasicScraper


class YAFGC(BasicScraper):
    latestUrl = 'http://yafgc.shipsinker.com/'
    imageUrl = 'http://yafgc.shipsinker.com/index.php?strip_id=%s'
    imageSearch = compile(r'(istrip_.+?)"')
    prevSearch = compile(r'(/.+?)">\r\n.+?prev.gif', MULTILINE)
    help = 'Index format: n'


class YouSayItFirst(BasicScraper):
    latestUrl = 'http://www.yousayitfirst.com/'
    imageUrl = 'http://www.soapylemon.com/comics/index.php?date=%s'
    imageSearch = compile(r'(http://.+?comics/.+?.jpg)[^<]')
    prevSearch = compile(r'(/comics/index.php\?date=.+?)".+?P')
    help = 'Index format: yyyymmdd'


class Yirmumah(BasicScraper):
    latestUrl = 'http://yirmumah.net/archives.php'
    imageUrl = 'http://yirmumah.net/archives.php?date=%s'
    imageSearch = compile(r'<img src="(strips/\d{8}\..*?)"')
    prevSearch = compile(r'<a href="(\?date=\d{8})">.*Previous')
    help = 'Index format: yyyymmdd'
